import com.rabbitmq.client.ConnectionFactory;
import com.rabbitmq.client.Connection;
import com.rabbitmq.client.Channel;

public class hello_sender
{
  private final static String QUEUE_NAME = "hello";
  
  public static void main(String[] argv) throws Exception
  {
    /* create connection */
    ConnectionFactory factory = new ConnectionFactory();
    factory.setHost("localhost");
    Connection connection = factory.newConnection();
    Channel channel = connection.createChannel();

    /* send to server*/
    boolean durable = true;
    channel.queueDeclare(QUEUE_NAME, durable, false, false, null);
    String message = "Hello World!";
    channel.basicPublish("", QUEUE_NAME, null, message.getBytes());
    System.out.println(" [x] Sent '" + message + "'");

    /* close channel */
    channel.close();
    connection.close();    
  }
}
